//
// Created by lydxh on 2024/5/9.
//
#include <stdio.h>
#include "tool.h"

float Mapping(float val, float I_Min, float I_Max, float O_Min, float O_Max) {
    return (((val - I_Min) * ((O_Max - O_Min) / (I_Max - I_Min))) + O_Min);
}

void BufPrint(char *name, void *buf, Type_t type, unsigned int len, unsigned char frame) {
    printf("\n%s:\n", name);
    for (int i = 0; i < len; ++i) {
        if (i % frame == 0 && i != 0) printf("\n");
        switch (type) {
            case U8:
                printf("%02X ", *((unsigned char *) buf + i));
                break;
            case U16:
                printf("%04X ", *((unsigned short *) buf + i));
                break;
            case U32:
                printf("%08X ", *((unsigned int *) buf + i));
                break;
            case CHAR:
                printf("%c ", *((char *) buf + i));
                break;
            case SHORT:
                printf("%d ", *((short *) buf + i));
                break;
            case INT:
                printf("%d ", *((int *) buf + i));
                break;
            case FLOAT:
                printf("%0.2f ", *((float *) buf + i));
                break;
            case DOUBLE:
                printf("%0.2f ", *((double *) buf + i));
                break;
            default:
                printf("未指定类型大小:%p", buf);
        }
    }
    printf("\n");
}